var firenes_options = {
	prefsfirenes: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.firenes."),
	tecla: "",
	teclaPref: "",

	restore: function (){
		if(document.getElementById('Sound').checked == false) document.getElementById('Sound').click();
		if(document.getElementById('Stereo').checked == false) document.getElementById('Stereo').click();
		if(document.getElementById('NiceSound').checked == false) document.getElementById('NiceSound').click();
		if(document.getElementById('FPS').checked == true) document.getElementById('FPS').click();
		if(document.getElementById('Scale').checked == false) document.getElementById('Scale').click();
		if(document.getElementById('Scanlines').checked == true) document.getElementById('Scanlines').click();
		if(document.getElementById('showsoundbuffer').checked == true) document.getElementById('showsoundbuffer').click();
		if(document.getElementById('Timeemulator').checked == false) document.getElementById('Timeemulator').click();
	},
	
	loadDefault: function(){
		document.getElementById('nesControlDefault').checked = firenes_options.prefsfirenes.getBoolPref('nes.control.default');
		document.getElementById('gbControlDefault').checked = firenes_options.prefsfirenes.getBoolPref('gb.control.default');

		firenes_options.controlLoadDefault('nes');
		firenes_options.controlLoadDefault('gb');
	},
	
	
	controlDefault: function(tipo) {
		var estado = !document.getElementById(tipo+'ControlDefault').checked;
		firenes_options.controlCambioDefault(tipo, estado);
	},

	controlLoadDefault: function(tipo) {
		var estado = firenes_options.prefsfirenes.getBoolPref(tipo+".control.default");
		firenes_options.controlCambioDefault(tipo, estado);

	},
	
	controlCambioDefault: function(tipo, estado) {
		document.getElementById(tipo+'1Up').disabled = estado;
		document.getElementById(tipo+'2Up').disabled = estado;
		document.getElementById(tipo+'1Down').disabled = estado;
		document.getElementById(tipo+'2Down').disabled = estado;
		document.getElementById(tipo+'1Left').disabled = estado;
		document.getElementById(tipo+'2Left').disabled = estado;
		document.getElementById(tipo+'1Right').disabled = estado;
		document.getElementById(tipo+'2Right').disabled = estado;
		document.getElementById(tipo+'1A').disabled = estado; 
		document.getElementById(tipo+'2A').disabled = estado; 
		document.getElementById(tipo+'1B').disabled = estado;
		document.getElementById(tipo+'2B').disabled = estado;
		document.getElementById(tipo+'1Select').disabled = estado;
		document.getElementById(tipo+'2Select').disabled = estado;
		document.getElementById(tipo+'1Start').disabled = estado;
		document.getElementById(tipo+'2Start').disabled = estado;
	},
	
	clickCambiarTecla: function(id,pref) {
		firenes_options.tecla = id;
		firenes_options.teclaPref = pref;
		document.getElementById('selectorTeclas').hidden = true;
		document.getElementById('cambiarTecla').hidden = false;
	},
	
	aceptarTecla: function() {
		var teclaElegida = document.getElementById('listaTeclas').value;
		
		document.getElementById(firenes_options.tecla).value = teclaElegida;
		firenes_options.prefsfirenes.setCharPref(firenes_options.teclaPref,teclaElegida);
		
		document.getElementById('selectorTeclas').hidden = false;
		document.getElementById('cambiarTecla').hidden = true;
	},
	
	cancelarTecla: function() {
		document.getElementById('selectorTeclas').hidden = false;
		document.getElementById('cambiarTecla').hidden = true;
	},
	
	donar: function() {
		firenes_options.entrar("https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=TCC9FJ8XTMS88&lc=US&item_name=FireNes&item_number=Firenes%20En&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted");
	},

	entrar: function(direccion) {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var mainWindow = wm.getMostRecentWindow("navigator:browser");
		mainWindow.focus(); 

		var newTabBrowser = mainWindow.gBrowser.getBrowserForTab(mainWindow.getBrowser().selectedTab = mainWindow.gBrowser.addTab(direccion));
		newTabBrowser.addEventListener("load", alCargar, true);
	}
};
